import React, { Component } from "react";
import './App.css';
import {
  FlexGrid
} from "@grapecity/wijmo.react.grid";
import {
  ComboBox
} from "@grapecity/wijmo.react.input";
import * as wjcCore from "@grapecity/wijmo";
import * as wjcGrid from "@grapecity/wijmo.grid";

class App extends Component {
  constructor() {
    super();
    this.state = {
      data: this.getData(50)
    };
  }

  loadTheme(name) {
    // apply new culture to page
    let url = `https://cdn.grapecity.com/wijmo/5.20193.637/styles/themes/wijmo.theme.${name}.min.css`,
      themes = document.getElementsByTagName("link");
    //
    for (let i = 0; i < themes.length; i++) {
      let theme = themes[i];
      if (theme.href.indexOf("styles/themes/wijmo.theme.") > -1) {
        theme.parentElement.removeChild(theme);
        break;
      }
    }
    //
    let theme = document.createElement("link");
    theme.rel = "stylesheet";
    theme.onload = () => {
      wjcCore.Control.refreshAll();
    };
    //
    theme.href = url;
    //
    document.head.appendChild(theme);
  }

  getData(count) {
    var countries = "US,Germany,UK,Japan,Italy,Greece".split(","),
      data = [];
    for (var i = 0; i < count; i++) {
      data.push({
        id: i,
        country: countries[i % countries.length],
        date: new Date(2014, i % 12, i % 28),
        amount: Math.random() * 10000,
        active: i % 4 === 0
      });
    }
    return new wjcCore.CollectionView(data);
  }

  initGrid(grid) {
    this.loadTheme('office');
  }

  indexChanged(s) {
    this.loadTheme(s.text);
  }

  render() {
    return (
      <div className="App">
        <ComboBox itemsSource={"office,cocoa,midnight,flatly".split(',')} textChanged={this.indexChanged.bind(this)} />
        <br /><br />
        <FlexGrid itemsSource={this.state.data} initialized={this.initGrid.bind(this)} />
      </div>
    );
  }
}

export default App;